.if !defined(PLESK_DEPENDS_MK)
PLESK_DEPENDS_MK= 1

# Create sorted list of dependencies for all depends
# and PRE_ depends.
# Delete invalid packages(witch exists into system but some 
# file from package was not found in system)
# create semaphores for right installed packages. 

# Correct depends list after deleting incorrect packages
# (cut installed packages from depends lists)
sw-depends:
	@if [ ! -z "${DEPENDS_FILE}" -a -f "${DEPENDS_FILE}" ]; then \
	    for _dep in $$(cat ${DEPENDS_FILE}); do \
		name="$${_dep##*/}"; \
		cd ${PORTSDIR}/$$_dep && \
	 	    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		    ${PORTUPGRADE} ${PORTUPGRADE_FLAGS} -P $$_dep && \
		    ${TOUCH} ${SW_WRKDIR}/.installed.$$name; \
	    done; \
	fi

sw-pre-depends: sw-do-mkdirs 
	@echo "===> Install pre-depends for ${PKGNAME}:"
	@echo "" > ${CHECKED_FILE}
	@depends="${PRE_DEPENDS}"; \
	${MAKE} DEPENDS="$$depends" sw-pre-depends-req
	@depends=$$(cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else { printf("%s ", $$2); dep[x[2]] = 1; }}'); \
	for _deps in $$depends; do \
	    echo "====> $$_deps"; \
	    echo "" > ${CHECKED_FILE}; \
	    echo "" > ${PRE_DEPENDS_LIST_FILE}; \
	    ${MAKE} DEPENDS="$$_deps" sw-depends-req; \
	    cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else { print $$2; dep[x[2]] = 1; }}' \
	    > ${PRE_DEPENDS_LIST_FILE}.tmp; \
	    ${MAKE} sw-drop-invalid-depends DEPENDS_FILE="${PRE_DEPENDS_LIST_FILE}.tmp"; \
	    for _dep in ${PRE_DEPENDS}; do \
		name="$${_dep##*/}"; \
		master_origin=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V PKGORIGIN); \
		installed=$$(pkg_version -s $$(pkg_info -qO $$master_origin) 2>/dev/null | awk '{print $$2}'); \
		if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
		    touch ${SW_WRKDIR}/.installed.$$name; \
		else \
	    	    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
			${PKG_DEINSTALL} -O -P -f $$master_origin 2>/dev/null || true; \
		    rm -f ${SW_WRKDIR}/.installed.$$name; \
		fi; \
	    done; \
	    for _dep in $$(cat ${PRE_DEPENDS_LIST_FILE}.tmp); do \
		name="$${_dep##*/}"; \
		if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		    echo "$$_dep" >> ${PRE_DEPENDS_LIST_FILE}; \
		fi; \
	    done; \
	    cd ${.CURDIR} && ${MAKE} DEPENDS_FILE="${PRE_DEPENDS_LIST_FILE}" \
		sw-install-options sw-fetch-depends sw-conflicts sw-depends; \
	    echo ""; \
	done

.if !exists(${DEPENDS_LIST_FILE})
sw-depends-list: sw-do-mkdirs
	@echo "===> Create list of depends for: ${PKGNAME}"
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@depends=$$(${MAKE} -V _DEPEND_DIRS | sed -e 's|${PORTSDIR}/||g'); \
        ${MAKE} DEPENDS="$$depends" sw-depends-req
	@echo ""
	@cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else {print $$2; dep[x[2]] = 1; }}' \
	 > ${DEPENDS_LIST_FILE}.tmp
	@echo "" > ${DEPENDS_LIST_FILE}
	@${MAKE} sw-drop-invalid-depends DEPENDS_FILE="${DEPENDS_LIST_FILE}.tmp"
	@for _dep in $$(cat ${DEPENDS_LIST_FILE}.tmp); do \
	    name="$${_dep##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		echo "$$_dep" >> ${DEPENDS_LIST_FILE}; \
	    fi; \
	done
.else
sw-depends-list:
.endif # DEPENDS_LIST_FILE

sw-depends-req:
	@for i in ${DEPENDS}; do \
	    if [ "$$__MKLVL__" = "20" ]; then \
		echo "Very deep recursion"; \
		exit 1; \
	    fi; \
	    name="$${i##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		sw_checked=$$(awk -v var1="$$__MKLVL__" -v var2="$$i" '{ \
			if (($$1 >= var1) && ($$2 == var2)) { print var1; exit; } \
		    }' ${CHECKED_FILE}); \
		if [ "X$$sw_checked" != "X$$__MKLVL__" ]; then \
		    echo "$$__MKLVL__ $$i" >> ${CHECKED_FILE}; \
		    depends=$$(cd ${PORTSDIR}/$$i && ${MAKE} -V _DEPEND_DIRS | sed -e 's|${PORTSDIR}/||g'); \
		    if [ ! -z "$$depends" ]; then \
			${MAKE} DEPENDS="$$depends" sw-depends-req; \
		    fi; \
		fi; \
	    fi; \
	    echo -n '.'; \
	done

sw-pre-depends-req:
	@for i in ${DEPENDS}; do \
	    if [ "$$__MKLVL__" = "20" ]; then \
		echo "Very deep recursion"; \
		exit 1; \
	    fi; \
	    name="$${i##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		echo "$$__MKLVL__ $$i" >> ${CHECKED_FILE}; \
		depends=$$(cd ${PORTSDIR}/$$i && ${MAKE} -V PRE_DEPENDS | sed -e 's|${PORTSDIR}/||g'); \
		if [ ! -z "$$depends" ]; then \
		    ${MAKE} DEPENDS="$$depends" sw-pre-depends-req; \
		fi; \
	    fi; \
	done

sw-drop-invalid-depends:
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@checklist=''; \
	for _dep in $$(cat ${DEPENDS_FILE}) ${SELF_ORIGIN}; do \
	    name="$${_dep##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		for i in $$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V LIB_DEPENDS | xargs echo -n); do \
		    portpath="$${i#*:}"; \
		    name="$${i##*/}"; \
		    sw_checked=$$(awk -v var=$$i '{if ($$1 == var) {print $$1;}}' ${CHECKED_FILE}); \
		    if [ "X$$sw_checked" = "X" ]; then \
			master_origin=$$(cd $$portpath && ${MAKE} -V PKGORIGIN); \
			installed=$$(pkg_version -s $$(pkg_info -qO $$master_origin) 2>/dev/null | awk '{print $$2}'); \
			if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			    lib=$${i%%:*}; \
			    case $$lib in \
				*.*.*)  pattern="`${ECHO_CMD} $$lib | ${SED} -e 's/\./\\\\./g'`" ;;\
				*.*)    pattern="$${lib%%.*}\.$${lib#*.}" ;;\
				*)  pattern="$$lib" ;;\
			    esac; \
			    if ${LDCONFIG} -r | ${GREP} -vwF -e "${PKGCOMPATDIR}" | ${GREP} -qwE -e "-l$$pattern"; then \
				touch ${SW_WRKDIR}/.installed.$$name; \
			    else \
				checklist="$$checklist $$master_origin"; \
			    fi; \
			else \
			    origin=$$(echo $$portpath | sed -e 's|${PORTSDIR}/||g'); \
			    if [ "$$origin" != "$$master_origin" ]; then \
				if [ "$${origin%/*}" = "swsoft" ]; then \
				    checklist="$$checklist $$master_origin"; \
				fi; \
			    fi; \
			    rm -f ${SW_WRKDIR}/.installed.$$name; \
			fi; \
			echo "$$i" >> ${CHECKED_FILE}; \
		    fi; \
		done; \
		for i in $$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V RUN_DEPENDS -V BUILD_DEPENDS | xargs echo -n); do \
		    portpath="$${i#*:}"; \
		    name="$${i##*/}"; \
		    sw_checked=$$(awk -v var=$$i '{if ($$1 == var) {print $$1;}}' ${CHECKED_FILE}); \
		    if [ "X$$sw_checked" = "X" ]; then \
			master_origin=$$(cd $$portpath && ${MAKE} -V PKGORIGIN); \
			installed=$$(pkg_version -s $$(pkg_info -qO $$master_origin) 2>/dev/null | awk '{print $$2}'); \
			if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			    prog=$${i%%:*}; \
			    if ${EXPR} "$$prog" : \\/ >/dev/null; then \
				if [ -e "$$prog" ]; then \
				    found=1; \
				else \
				    found=0; \
				fi; \
			    else \
				prog=$$(echo $$prog | sed -e 's/[<|>|=].*//g'); \
				if ${WHICH} "$$prog" > /dev/null 2>&1 ; then \
				    found=1; \
				else \
				    found=0; \
				fi; \
			    fi; \
			    if [ $$found = 0 ]; then \
				checklist="$$checklist $$master_origin"; \
			    else \
				touch ${SW_WRKDIR}/.installed.$$name; \
			    fi; \
			else \
			    origin=$$(echo $$portpath | sed -e 's|${PORTSDIR}/||g'); \
			    if [ "$$origin" != "$$master_origin" ]; then \
				if [ "$${origin%/*}" = "swsoft" ]; then \
				    checklist="$$checklist $$master_origin"; \
				fi; \
			    fi; \
			    rm -f ${SW_WRKDIR}/.installed.$$name; \
			fi; \
			echo "$$i" >> ${CHECKED_FILE}; \
		    fi; \
		done; \
	    fi; \
	    echo -n '.'; \
	done; \
	if [ "X$$checklist" != "X" ]; then \
	    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		${PKG_DEINSTALL} -O -P -f $$checklist 2>/dev/null || true; \
	    for i in $$checklist; do \
		name="$${i##*/}"; \
		rm -f ${SW_WRKDIR}/.installed.$$name; \
	    done; \
	fi

.endif # PLESK_DEPENDS_MK

