.if !defined(PLESK_FETCH_MK)
PLESK_FETCH_MK= 1

sw-fetch-depends: 
	@echo ""
	@echo "==> Fetch all depends for: ${PKGNAME}"
	@${MKDIR} -p ${PACKAGES}/All
	@${MKDIR} -p ${FETCHDIR}
	@_fetch_urls=$$(PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	ruby -e 'require "pkgtools"; init_pkgtools_global; load_config(); \
		$$pkg_sites.map { |i| print i; print "\n"}'); \
	for _dep in $$(cat ${DEPENDS_FILE}) ${SELF_ORIGIN}; do \
	    echo "---> $$_dep"; \
	    name="$${_dep##*/}"; \
	    if [ ! -f ${SW_WRKDIR}/.installed.$$name ]; then \
		_chksum=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V NO_CHECKSUM); \
		_extract=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V NO_EXTRACT); \
		echo $$_dep | grep -q ${SW_CATEGORY} && cd ${PORTSDIR}/$$_dep && ${MAKE} sw-pre-fetch || true; \
		if [ -z "$$_extract" -a -z "$$_chksum" ]; then \
		    sum_file=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V MD5_FILE); \
		    dist_file=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V DISTFILES); \
		    dist_subdir=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V DIST_SUBDIR); \
		    dist_dir=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V DISTDIR); \
		    for _dist in $$dist_file; do \
			if [ ! -z $$dist_subdir ]; then \
			    _dist="$$dist_subdir/$$_dist"; \
			fi; \
			if [ -f $$dist_dir/$$_dist ]; then \
			    file=$$(${MD5} $$dist_dir/$$_dist 2>/dev/null | ${AWK} -F '=' '{print $$2}'); \
			    sum=$$(${CAT} $$sum_file | grep $$_dist | ${AWK} -F '=' '/^MD5/ {print $$2;}'); \
			    if [ "$$sum" != "$$file" ]; then \
				rm -f $$dist_dir/$$_dist; \
			    fi; \
			fi; \
		    done; \
		fi; \
		if [ -z "$$_extract" ]; then \
		    _pkg=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V PKGNAME); \
		    for _list in $$_fetch_urls; do \
			if [ ! -f "${PACKAGES}/All/$$_pkg.tbz" ]; then \
			    cd ${PACKAGES}/All/ && ${FETCH_CMD} $${_list}All/$$_pkg.tbz || continue; \
			fi; \
		    done; \
		    if [ ! -f "${PACKAGES}/All/$$_pkg.tbz" -a ! -f $$dist_dir/$$_dist ]; then \
			cd ${PORTSDIR}/$$_dep && ${MAKE} fetch; \
		    fi; \
		fi; \
	    fi; \
	done

sw-pre-fetch:
.   if defined(FETCH_SITES_LIST) && defined(FETCH_FILES_LIST) 
.      for _list in ${FETCH_SITES_LIST}
.        for _files in ${FETCH_FILES_LIST}
.	     if !exists(${FETCHDIR}/${_files})
		@cd ${FETCHDIR} && /usr/bin/fetch -FR ${_list}/${_files} || continue
.            endif
.        endfor
.      endfor
.   endif

.endif # PLESK_FETCH_MK
