#This Plesk mk-file. Need for using portupgrade for update and install standart packages 
#from ports. Packages may be installed from various repositories (defined in portupgrade's
# config file.
#Target may be redefined in Makefile of port. Definiton some targets must to be before 
#include this file.
#

.if !defined(_PREMKINCLUDED)
.include <bsd.port.pre.mk>
.endif

# Common options
# ------------------
.include <plesk.common.mk>

# Redefine main targets if ${MASTERDIR} = ${.CURDIR}
# ------------------
.if !defined(USE_NATIVE_MK)
.include <plesk.targets.mk>
.endif # USE_NATIVE_MK 

#------------------------------------------------------------------------------------------
# Target empty for compatibility with previous versions. 
#------------------------------------------------------------------------------------------
sw-install-check:

all-conflicts:

.if !target(product-pre-cmd)
product-pre-cmd: 
.endif

sw-do-mkdirs:
	@mkdir -p ${WRKDIR}
	@mkdir -p ${SW_WRKDIR}

sw-install-options:
	@if [ ! -z "${DEPENDS_FILE}" -a -f "${DEPENDS_FILE}" ]; then \
	    for _dep in $$(cat ${DEPENDS_FILE}); do \
		opts=$$(cd ${PORTSDIR}/$$_dep && make -V OPTIONS:C/\".*\"/=/g); \
		if [ ! -z "$$opts" ]; then \
		    optionsfile=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V OPTIONSFILE); \
		    if [ ! -f "$$optionsfile" ]; then \
			${MKDIR} -p $${optionsfile%/*}; \
			opts=$$(echo $$opts | sed -e 's|[Oo][Nn]|true\||g' -e 's|[Oo][Ff][Ff]|\||g'  \
							    -e 's|[[:space:]]||g' -e 's|\|| |g'); \
			pkgname=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V PKGNAME); \
			echo "_OPTIONS_READ=$$pkgname" > $$optionsfile; \
			for opt in $$opts; do \
			    _var="$${opt%=*}"; \
			    _res=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} -V WITH_$$_var); \
			    if [ ! -z "$$_res" ]; then  \
				echo "WITH_$${_var}=true" >> $$optionsfile; \
			    else \
				echo "WITHOUT_$${_var}=true" >> $$optionsfile; \
			    fi; \
			done; \
		    fi; \
		fi; \
		echo -n "."; \
	    done; \
	fi 

# Test ports tree and throw exeption if found BROKEN 
# ports which need for own products
# ------------------
sw-test-ports:
	@echo "===> Checking ports marked as BROKEN or IGNORE"
	@depends=$$(${MAKE} all-depends-list | sed -e 's|${PORTSDIR}/||g'); \
	for dep in $$depends ${PKGORIGIN}; do \
	    _test_cmd=$$(cd ${PORTSDIR}/$$dep && ${MAKE} -V FORBIDDEN); \
	    if [ ! -z "$$_test_cmd" ]; then \
		forbidden="$$forbidden $$dep"; \
	    fi; \
	    _test_cmd=$$(cd ${PORTSDIR}/$$dep && ${MAKE} -V IGNORE); \
	    if [ ! -z "$$_test_cmd" ]; then \
		ignored="$$ignored $$dep"; \
	    fi; \
	done; \
	if [ ! -z "$$ignored" ]; then \
	    echo "Warning: Follow ports mark as ignored but was installed now:"; \
	    for i in $$ignored; do \
		echo "   $$dep: $$(cd ${PORTSDIR}/$$dep && ${MAKE} -V IGNORE)"; \
	    done; \
	    echo ""; \
	fi; \
	if [ ! -z "$$forbidden" ]; then \
	    echo "ERROR!!!: Follow ports mark as FORBIDDEN:"; \
	    for i in $$forbidden; do \
		echo "   $$dep: $$(cd ${PORTSDIR}/$$dep && ${MAKE} -V FORBIDDEN)"; \
	    done; \
	    echo ""; \
	    echo "Installation failed"; \
	    echo "Please use ports with another tag or use ports distributed by SwSoft."; \
	    exit 1; \
	fi

.if !target(product-post-cmd)
product-post-cmd:
.endif

.if !defined(NO_SW_DEPENDS)
NO_SW_DEPENDS= 1
.include <plesk.depends.mk>
.endif

.if !defined(NO_SW_FETCH)
NO_SW_FETCH= 1
.include <plesk.fetch.mk>
.endif

.if !defined(NO_SW_CONFLICTS)
NO_SW_CONFLICTS= 1
.include <plesk.conflicts.mk>
.endif

#-------------------------------------------------------------------------------------------
# Indexes
#-------------------------------------------------------------------------------------------
do-index:
	@describe=$$(${MAKE} describe); \
	if [ "X$$describe" != "X" ]; then \
		origin=$$(echo $$describe | awk -F '|' '{print $$2}'| sed -e 's|^${PORTSDIR}/\(.*\)|\1|g'); \
		portname=$$(echo $$describe | awk -F '|' '{print $$1}'| sed -e 's|\(.*\)\-[[:digit:]]*.*|\1|g'); \
		if ! ${GREP} -q "^$$portname-[[:digit:]]" ${INDEXDIR}/${INDEXFILE} > /dev/null; then \
			echo $$describe >> ${INDEXDIR}/${INDEXFILE}; \
		else \
			sed -i "" -e "s#^$$portname-[[:digit:]]\(.*\)|${PORTSDIR}/$$origin\|\(.*\)#$$describe#" ${INDEXDIR}/${INDEXFILE}; \
		fi; \
	else \
.               error "Inconsistent port"; \
	fi

index: do-index

#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.if !defined(_POSTMKINCLUDED)
.include <bsd.port.post.mk>
.endif 

.if defined(USE_PHP)
.include "${PORTSDIR}/Mk/bsd.php.mk"
.endif

#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

sw-update-db:
	@PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    pkgdb -aFu
	@PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    portsdb -fu; 

sw-install:
	@if [ ! -f ${INSTALLED_FILE} ]; then \
	    ${MAKE} sw-pre-depends sw-depends-list; \
	    ${MAKE} DEPENDS_FILE="${DEPENDS_LIST_FILE}" \
		sw-conflicts sw-install-options sw-fetch-depends sw-depends; \
	    PKGTOOLS_CONF=${PKGTOOLS_CONF} \
		${PORTUPGRADE} ${PORTUPGRADE_FLAGS} ${PKGORIGIN}; \
	    ${MAKE} sw-update-db; \
	    installed=$$(pkg_version -s $$(pkg_info -qO ${PKGORIGIN}) 2>/dev/null | awk '{print $$2}'); \
	    if [ "$$installed" = '=' ]; then \
		${TOUCH} ${INSTALLED_FILE}; \
	    fi; \
	fi
